## cpu-x 5.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
# https://cmake.org/cmake/help/latest/policy/CMP0177.html
if(POLICY CMP0177)
	cmake_policy(SET CMP0177 NEW)
endif()
project(cpu-x
	VERSION "5.2.0"
	LANGUAGES C CXX
)

if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD")
	message(WARNING "'${CMAKE_SYSTEM_NAME}' system is not officially supported by CPU-X, some features will not be available.")
endif(NOT CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD")
if(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)|^armv.*|aarch64")
	message(FATAL_ERROR "'${CMAKE_SYSTEM_PROCESSOR}' processor is not supported by CPU-X.")
endif(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)|^armv.*|aarch64")


### DEFAULT CONFIG

# Global variables
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
include(GNUInstallDirs)
# Avoid to put files under /usr/libexec or /usr/local/libexec on Linux when the path does not exist
# On FreeBSD, /usr/local/libexec is missing under Poudriere (https://gitlab.com/FreeBSD/freebsd-ports/-/commit/eb6c9c8c4aa5981078c6b9b69527ecdaee5f22c9)
if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
	set(CMAKE_INSTALL_LIBEXECDIR      lib/${CMAKE_PROJECT_NAME})
	set(CMAKE_INSTALL_FULL_LIBEXECDIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR})
endif(CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/output/bin/)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/output/lib/)
set(CMAKE_DATA_OUTPUT_DIRECTORY    ${CMAKE_BINARY_DIR}/output/data/)
set(CPU_X_DATA_DIRECTORY           ${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}/)
set(APP_EXEC                       ${CMAKE_PROJECT_NAME})
set(DAEMON_EXEC                    ${CMAKE_PROJECT_NAME}-daemon)
set(DAEMON_PATH                    ${CMAKE_INSTALL_FULL_LIBEXECDIR}/${DAEMON_EXEC})
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	set(DAEMON_SOCKET              "/run/cpu-x.sock")
else()
	set(DAEMON_SOCKET              "/var/run/cpu-x.sock")
endif(CMAKE_SYSTEM_NAME MATCHES "Linux")
if(CMAKE_SIZEOF_VOID_P EQUAL 4)
	set(BITNESS "32")
else(CMAKE_SIZEOF_VOID_P EQUAL 4)
	set(BITNESS "64")
endif(CMAKE_SIZEOF_VOID_P EQUAL 4)
set(CMAKE_COLOR_DIAGNOSTICS ON)
set(CMAKE_C_FLAGS             "${CMAKE_C_FLAGS} -Wno-unused-result")
set(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS} -Wpedantic -Wno-unused-result -Wno-psabi")
set(CMAKE_C_FLAGS_DEBUG       "${CMAKE_C_FLAGS_DEBUG} -Wall -Wextra -Wuninitialized -Wformat -Wformat-security -Wstrict-prototypes")
set(CMAKE_CXX_FLAGS_DEBUG     "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Wuninitialized -Wformat -Wformat-security")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")

include(CheckCCompilerFlag)
check_c_compiler_flag("-no-pie" HAS_NO_PIE)
if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND HAS_NO_PIE)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -no-pie")
endif(CMAKE_SYSTEM_NAME MATCHES "Linux" AND HAS_NO_PIE)

# Options
option(WITH_GTK           "Build support for GUI in GTK3+"                                    ON)
option(WITH_NCURSES       "Build support for TUI in NCurses"                                  ON)
option(WITH_GETTEXT       "Build support for internationalization"                            ON)
option(WITH_LIBCPUID      "Use Libcpuid library"                                              ON)
option(WITH_LIBPCI        "Use Libpci library"                                                ON)
option(WITH_LIBEGL        "Use Libegl library"                                                ON)
option(WITH_VULKAN        "Use Vulkan library"                                                ON)
option(WITH_OPENCL        "Use OpenCL library"                                                ON)
option(WITH_LIBPROCPS     "Use Libprocps library"                                             ON)
option(WITH_LIBSTATGRAB   "Use Libstatgrab library"                                           ON)
option(WITH_DMIDECODE     "Built-in Dmidecode"                                                ON)
if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
	option(WITH_BANDWIDTH "Built-in Bandwidth"                                                ON) # Bandwidth is only supported on x86 CPUs (requires cache size)
else()
	set(WITH_BANDWIDTH OFF)
endif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
option(FORCE_LIBSTATGRAB  "Force use of Libstatgrab instead of Libprocps (GNU/Linux system)"  OFF)
option(APPIMAGE           "Enable workarounds for AppImage"                                   OFF)
option(FLATPAK            "Enable workarounds for Flatpak"                                    OFF)

# Colours
string(ASCII 27 Esc)
set(ColourReset "${Esc}[m")
set(ColourBold  "${Esc}[1m")
set(Red         "${Esc}[31m")
set(Green       "${Esc}[32m")
set(Yellow      "${Esc}[33m")
set(Blue        "${Esc}[34m")
set(Magenta     "${Esc}[35m")
set(Cyan        "${Esc}[36m")
set(White       "${Esc}[37m")
set(BoldRed     "${Esc}[1;31m")
set(BoldGreen   "${Esc}[1;32m")
set(BoldYellow  "${Esc}[1;33m")
set(BoldBlue    "${Esc}[1;34m")
set(BoldMagenta "${Esc}[1;35m")
set(BoldCyan    "${Esc}[1;36m")
set(BoldWhite   "${Esc}[1;37m")


### MACROS

# Macro: print_config(libname foundstate withstate)
# Print the state of CPU-X features: in bold green if enabled, else bold red.
# @libname:    library name (e.g. GTK)
# @libver:     library version (e.g. XXXXX_VERSION)
# @foundstate: the result of pkg_check_modules(...) (e.g. XXXXX_FOUND)
# @withstate:  the CMake option which allows to disable this feature (e.g. WITH_XXXXX)
macro(print_config libname libver foundstate withstate)
	if(${foundstate} AND ${withstate})
		message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldGreen}enabled${ColourReset}")
		add_definitions(-DHAS_${libname}=1 -D${libname}_VERSION="${libver}")
	else(${foundstate} AND ${withstate})
		if(NOT ${withstate})
			message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset} (explicitly disabled)")
		elseif(NOT ${foundstate})
			message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset} (not found by pkg-config)")
		endif()
		add_definitions(-DHAS_${libname}=0 -D${libname}_VERSION=NULL)
	endif(${foundstate} AND ${withstate})
endmacro(print_config)


### HELPERS / SUBDIRECTORIES

set(GIT_REVISION "")
if(EXISTS ${CMAKE_SOURCE_DIR}/.git)
	find_package(Git)
	if(GIT_FOUND)
		execute_process(COMMAND sh -c "${GIT_EXECUTABLE} describe --long --tags --exclude continuous --abbrev=40 --dirty | cut --delimiter=- --fields=2-"
			WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
			OUTPUT_VARIABLE GIT_DESCRIBE_REVISION
			ERROR_QUIET
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
		if(NOT GIT_DESCRIBE_REVISION STREQUAL "")
			set(GIT_REVISION "+git-r${GIT_DESCRIBE_REVISION}")
		endif(NOT GIT_DESCRIBE_REVISION STREQUAL "")
	endif(GIT_FOUND)
endif(EXISTS ${CMAKE_SOURCE_DIR}/.git)

enable_testing()
find_package(PkgConfig REQUIRED)
find_package(Threads REQUIRED)
find_package(Backtrace REQUIRED)
find_package(Filesystem REQUIRED)
if(WITH_GETTEXT)
	find_package(Gettext)
	if(${CMAKE_VERSION} VERSION_GREATER "3.1")
		find_package(Intl)
	endif(${CMAKE_VERSION} VERSION_GREATER "3.1")
endif(WITH_GETTEXT)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(CheckCSourceCompiles)
include(CheckIncludeFile)
add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(tests)


### UNINSTALL TARGET

configure_file("${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY
)

add_custom_target(uninstall
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

=== src/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

### TIP: CMake commands orders
# - link_directories: The command will apply only to targets created after it is called.
# - add_executable: Adds an executable target called <name> to be built from the source files listed in the command invocation.
#                   (The source files can be omitted here if they are added later using target_sources().)
# - target_sources: The named <target> must have been created by a command such as add_executable().


### FIND REQUIRED LIBRAIRIES

# GTK3+
if(WITH_GTK)
	set(MINIMUM_GTK_VERSION 3.12.0)
	pkg_check_modules(GTK3 gtkmm-3.0>=${MINIMUM_GTK_VERSION})
	if(GTK3_FOUND)
		include_directories(${GTK3_INCLUDE_DIRS})
		link_directories(${GTK3_LIBRARY_DIRS})
		add_definitions(${GTK3_CFLAGS_OTHER})
	else(GTK3_FOUND)
		message("${BoldYellow}GTK3+ GUI will not be build:${ColourReset} ${Yellow}GTK ${MINIMUM_GTK_VERSION} or higher is needed.${ColourReset}")
		message("${Yellow}Set ${BoldYellow}PKG_CONFIG_PATH${ColourReset}${Yellow} environment variable if development files are installed.${ColourReset}")
	endif(GTK3_FOUND)
endif(WITH_GTK)

# NCurses
if(WITH_NCURSES)
	pkg_check_modules(NCURSES ncursesw)
	# Assume ncurses from the base on FreeBSD
	if(NOT NCURSES_FOUND AND CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
		set(NCURSES_FOUND 1)
		set(NCURSES_LIBRARIES "-l:libncursesw.so")
	endif()
	if(NCURSES_FOUND)
		include_directories(${NCURSES_INCLUDE_DIRS})
		link_directories(${NCURSES_LIBRARY_DIRS})
	endif(NCURSES_FOUND)
endif(WITH_NCURSES)

# Gettext
if(Intl_FOUND)
	include_directories(${Intl_INCLUDE_DIRS})
endif(Intl_FOUND)

# Libcpuid
if(WITH_LIBCPUID)
	pkg_check_modules(LIBCPUID libcpuid>=0.7.0)
	if(LIBCPUID_FOUND)
		include_directories(${LIBCPUID_INCLUDE_DIRS})
		link_directories(${LIBCPUID_LIBRARY_DIRS})
		add_definitions(${LIBCPUID_CFLAGS_OTHER})
		set(CMAKE_REQUIRED_LIBRARIES ${LIBCPUID_LIBRARIES})
	endif(LIBCPUID_FOUND)
endif(WITH_LIBCPUID)

# Libpci
if(WITH_LIBPCI)
	pkg_check_modules(LIBPCI libpci)
	if(LIBPCI_FOUND)
		include_directories(${LIBPCI_INCLUDE_DIRS})
		link_directories(${LIBPCI_LIBRARY_DIRS})
		add_definitions(${LIBPCI_CFLAGS_OTHER})
	endif(LIBPCI_FOUND)
endif(WITH_LIBPCI)

# Libegl
if(WITH_LIBEGL)
	pkg_check_modules(LIBGL gl)
	pkg_check_modules(LIBEGL egl>1.4)
	if(LIBGL_FOUND AND LIBEGL_FOUND)
		include_directories(${LIBGL_INCLUDE_DIRS} ${LIBEGL_INCLUDE_DIRS})
		link_directories(${LIBGL_LIBRARY_DIRS} ${LIBEGL_LIBRARY_DIRS})
		add_definitions(${LIBGL_CFLAGS_OTHER} ${LIBEGL_CFLAGS_OTHER})
		set(LIBOPENGL_LIBRARIES ${LIBGL_LIBRARIES} ${LIBEGL_LIBRARIES})
	endif(LIBGL_FOUND AND LIBEGL_FOUND)
endif(WITH_LIBEGL)

# Vulkan
if(WITH_VULKAN)
	pkg_check_modules(VULKAN vulkan)
	if(VULKAN_FOUND)
		include_directories(${VULKAN_INCLUDE_DIRS})
		link_directories(${VULKAN_LIBRARY_DIRS})
		add_definitions(${VULKAN_CFLAGS_OTHER})
	endif(VULKAN_FOUND)
endif(WITH_VULKAN)

# OpenCL
if(WITH_OPENCL)
	pkg_check_modules(OPENCL OpenCL)
	if(OPENCL_FOUND)
		include_directories(${LIBOPENCL_INCLUDE_DIRS} ${OpenCL_INCLUDE_DIRS})
		link_directories(${LIBOPENCL_LIBRARY_DIRS} ${OpenCL_LIBRARY_DIRS})
		add_definitions(${LIBOPENCL_CFLAGS_OTHER} ${OpenCL_CFLAGS_OTHER})
	endif(OPENCL_FOUND)
endif(WITH_OPENCL)

# Libprocps
set(LIBSYSTEM_LIBRARIES)
set(LIBSYSTEM 0)
set(LIBPROC2 -1)
if(WITH_LIBPROCPS AND CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
	pkg_check_modules(LIBPROC2 libproc2)
	if(LIBPROC2_FOUND)
		include_directories(${LIBPROC2_INCLUDE_DIRS})
		link_directories(${LIBPROC2_LIBRARY_DIRS})
		add_definitions(${LIBPROC2_CFLAGS_OTHER})
		set(LIBSYSTEM_LIBRARIES ${LIBPROC2_LIBRARIES})
		set(LIBSYSTEM 1)
		set(LIBPROC2 1)
	else()
		pkg_check_modules(LIBPROCPS libprocps)
		set(LIBPROC2 0)
	endif()
	if(LIBPROCPS_FOUND)
		include_directories(${LIBPROCPS_INCLUDE_DIRS})
		link_directories(${LIBPROCPS_LIBRARY_DIRS})
		add_definitions(${LIBPROCPS_CFLAGS_OTHER})
		set(LIBSYSTEM_LIBRARIES ${LIBPROCPS_LIBRARIES})
		set(LIBSYSTEM 1)
	endif(LIBPROCPS_FOUND)
endif(WITH_LIBPROCPS AND CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)

# Libstatgrab
if(WITH_LIBSTATGRAB AND (NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR FORCE_LIBSTATGRAB))
	pkg_check_modules(LIBSTATGRAB libstatgrab)
	if(LIBSTATGRAB_FOUND)
		include_directories(${LIBSTATGRAB_INCLUDE_DIRS})
		link_directories(${LIBSTATGRAB_LIBRARY_DIRS})
		add_definitions(${LIBSTATGRAB_CFLAGS_OTHER})
		set(LIBSYSTEM_LIBRARIES ${LIBSTATGRAB_LIBRARIES})
		set(LIBSYSTEM 2)
	endif(LIBSTATGRAB_FOUND)
endif(WITH_LIBSTATGRAB AND (NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR FORCE_LIBSTATGRAB))

# Dmidecode
if(WITH_DMIDECODE)
	add_subdirectory(core/dmidecode)
	include_directories(core/dmidecode)
	set(DMIDECODE_LIBRARIES "dmidecode")
endif(WITH_DMIDECODE)

# Bandwidth
if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" AND WITH_BANDWIDTH)
	add_subdirectory(core/bandwidth)
	if(BANDWIDTH_FOUND)
		include_directories(core/bandwidth)
		set(BANDWIDTH_LIBRARIES "bandwidth")
	endif(BANDWIDTH_FOUND)
endif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" AND WITH_BANDWIDTH)


### FINAL CONFIG

message("${BoldCyan}** ${CMAKE_PROJECT_NAME} ${PROJECT_VERSION} configuration (${CMAKE_SYSTEM_PROCESSOR}) **${ColourReset}")

# UI libraries
print_config("GTK"                 "${GTK3_VERSION}"        GTK3_FOUND        WITH_GTK)
print_config("NCURSES"             "${NCURSES_VERSION}"     NCURSES_FOUND     WITH_NCURSES)

# Other libraries
print_config("GETTEXT"             0                        GETTEXT_FOUND     WITH_GETTEXT)
print_config("LIBCPUID"            "${LIBCPUID_VERSION}"    LIBCPUID_FOUND    WITH_LIBCPUID)
print_config("LIBPCI"              "${LIBPCI_VERSION}"      LIBPCI_FOUND      WITH_LIBPCI)
print_config("LIBEGL"              "${LIBEGL_VERSION}"      LIBEGL_FOUND      WITH_LIBEGL)
print_config("VULKAN"              "${VULKAN_VERSION}"      VULKAN_FOUND      WITH_VULKAN)
print_config("OPENCL"              "${OPENCL_VERSION}"      OPENCL_FOUND      WITH_OPENCL)
if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
	if(${LIBPROC2} EQUAL 1)
		print_config("LIBPROC2"    "${LIBPROC2_VERSION}"    LIBPROC2_FOUND    WITH_LIBPROCPS)
	else()
		print_config("LIBPROCPS"   "${LIBPROCPS_VERSION}"   LIBPROCPS_FOUND   WITH_LIBPROCPS)
	endif()
else()
	print_config("LIBSTATGRAB" "${LIBSTATGRAB_VERSION}" LIBSTATGRAB_FOUND WITH_LIBSTATGRAB)
endif()

# Subprojects
print_config("DMIDECODE"           "${DMIDECODE_VERSION}"   1                 WITH_DMIDECODE)
print_config("BANDWIDTH"           "${BANDWIDTH_VERSION}"   BANDWIDTH_FOUND   WITH_BANDWIDTH)


### BINARIES

# Executables
add_executable(${APP_EXEC}
	core/benchmarks.cpp
	core/core.cpp
	core/core.hpp
	core/internal.hpp
	daemon/client.cpp
	daemon/client.hpp
	daemon/daemon.h
	data.cpp
	data.hpp
	logger.cpp
	logger.hpp
	main.cpp
	options.cpp
	options.hpp
	util.cpp
	util.hpp
)

add_executable(${DAEMON_EXEC}
	daemon/server.cpp
	daemon/server.hpp
	daemon/daemon.h
	data.cpp
	data.hpp
	logger.cpp
	logger.hpp
	options.cpp
	options.hpp
	util.cpp
	util.hpp
)


# Additional source files
# GTK3+
if(WITH_GTK AND GTK3_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		ui/gtk.cpp
		ui/gtk.hpp
	)
endif(WITH_GTK AND GTK3_FOUND)

# NCurses
if(WITH_NCURSES AND NCURSES_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		ui/ncurses.cpp
		ui/ncurses.hpp
	)
endif(WITH_NCURSES AND NCURSES_FOUND)

# Libcpuid
if(WITH_LIBCPUID AND LIBCPUID_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libcpuid.cpp
		core/databases.h
	)
	target_sources(${DAEMON_EXEC}
		PRIVATE
		core/libcpuid.cpp
		core/databases.h
	)
endif(WITH_LIBCPUID AND LIBCPUID_FOUND)

# Libpci
if(WITH_LIBPCI AND LIBPCI_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libpci.cpp
	)
endif(WITH_LIBPCI AND LIBPCI_FOUND)

# Libegl
if(WITH_LIBEGL AND LIBGL_FOUND AND LIBEGL_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libopengl.cpp
	)
endif(WITH_LIBEGL AND LIBGL_FOUND AND LIBEGL_FOUND)

# Vulkan
if(WITH_VULKAN AND VULKAN_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libvulkan.cpp
	)
endif(WITH_VULKAN AND VULKAN_FOUND)

# OpenCL
if(WITH_OPENCL AND OPENCL_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libopencl.cpp
		core/opencl_ext.h
	)
endif(WITH_OPENCL AND OPENCL_FOUND)

# Libsystem (libproc2/libprocps/libstatgrab)
if(${LIBSYSTEM} GREATER 0)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libsystem.cpp
	)
endif(${LIBSYSTEM} GREATER 0)

# Dmidecode
if(WITH_DMIDECODE)
	target_sources(${APP_EXEC}
		PRIVATE
		core/dmidecode/libdmidecode.cpp
		core/dmidecode/libdmidecode.h
	)
	target_sources(${DAEMON_EXEC}
		PRIVATE
		core/dmidecode/libdmidecode.cpp
		core/dmidecode/libdmidecode.h
	)
endif(WITH_DMIDECODE)

# Bandwidth
if(WITH_BANDWIDTH AND BANDWIDTH_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/bandwidth/libbandwidth.cpp
		core/bandwidth/libbandwidth.h
	)
endif(WITH_BANDWIDTH AND BANDWIDTH_FOUND)


### DEFINITIONS & LINK

# Libsystem extra-definitions
if(${LIBSYSTEM} EQUAL 0 OR ${LIBSYSTEM} EQUAL 1) # When Libprocps is used
	add_definitions(-DHAS_LIBSTATGRAB=0 -DLIBSTATGRAB_VERSION=NULL)
	if(${LIBPROC2} EQUAL 1)
		add_definitions(-DHAS_LIBPROCPS=0 -DLIBPROCPS_VERSION=NULL)
	else(${LIBPROC2} EQUAL 0)
		add_definitions(-DHAS_LIBPROC2=0  -DLIBPROC2_VERSION=NULL)
	endif()
endif()
if(${LIBSYSTEM} EQUAL 0 OR ${LIBSYSTEM} EQUAL 2) # When Libstatgrab is used
	add_definitions(-DHAS_LIBPROC2=0  -DLIBPROC2_VERSION=NULL)
	add_definitions(-DHAS_LIBPROCPS=0 -DLIBPROCPS_VERSION=NULL)
endif()

# ARM CPUs workarounds
if(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64" AND CMAKE_SYSTEM_NAME MATCHES "Linux")
	set(OTHER_LIBRARIES "-latomic")
endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64" AND CMAKE_SYSTEM_NAME MATCHES "Linux")

# AppImage workarounds
if(APPIMAGE)
	add_definitions(-DAPPIMAGE
		-DDAEMON_TMP_EXEC="/tmp/${DAEMON_EXEC}"
	)
endif(APPIMAGE)

# Flatpak workarounds
if(FLATPAK)
	add_definitions(-DFLATPAK)
	set(DAEMON_SOCKET cpu-x.sock)
	if(LIBCPUID_FOUND)
		# flatpak-spawn command will not be able to find libcpuid.so when starting cpu-x-daemon
		set(LIBCPUID_LIBRARIES "-l:libcpuid.a")
	endif(LIBCPUID_FOUND)
endif(FLATPAK)

# Various definitions
add_definitions(-DPRGVER="${PROJECT_VERSION}"
	-DGITREV="${GIT_REVISION}"
	-DSYSTEM_NAME="${CMAKE_SYSTEM_NAME}"
	-DSYSTEM_PROCESSOR="${CMAKE_SYSTEM_PROCESSOR}"
	-DC_COMPILER_ID="${CMAKE_C_COMPILER_ID}"
	-DHAS_LIBSYSTEM=${LIBSYSTEM}
	-DGETTEXT_PACKAGE="${CMAKE_PROJECT_NAME}"
	-DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
	-DCPUX_DATA_DIRECTORY="${CPU_X_DATA_DIRECTORY}"
	-DTERMINFODIR="/lib/terminfo"
	-DDAEMON_EXEC="${DAEMON_EXEC}"
	-DDAEMON_PATH="${DAEMON_PATH}"
	-DSOCKET_NAME="${DAEMON_SOCKET}"
)

# Link libraries
target_link_libraries(${APP_EXEC}
	${Intl_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT}
	${Backtrace_LIBRARIES}
	std::filesystem

	${GTK3_LIBRARIES}
	${NCURSES_LIBRARIES}
	${LIBCPUID_LIBRARIES}
	${LIBPCI_LIBRARIES}
	${LIBOPENGL_LIBRARIES}
	${VULKAN_LIBRARIES}
	${OPENCL_LIBRARIES}
	${LIBSYSTEM_LIBRARIES}
	${DMIDECODE_LIBRARIES}
	${BANDWIDTH_LIBRARIES}
	${OTHER_LIBRARIES}
)

target_link_libraries(${DAEMON_EXEC}
	${Intl_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT}
	std::filesystem

	${LIBCPUID_LIBRARIES}
	${DMIDECODE_LIBRARIES}
)


### INSTALLATION

install(TARGETS ${APP_EXEC}    DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}/)
install(TARGETS ${DAEMON_EXEC} DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}/)

=== src/core/dmidecode/CMakeLists.txt ===
project(dmidecode
	VERSION "3.6.20250213"
	LANGUAGES C
)

# Config (dmidecode)
set(CMAKE_C_FLAGS       "${CMAKE_C_FLAGS}")
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wno-shift-count-overflow")
message(STATUS "Using built-in ${PROJECT_NAME}, version ${PROJECT_VERSION}")

# Build (dmidecode)
add_definitions(-DVERSION="${PROJECT_VERSION}")
add_library(dmidecode
	STATIC
	types.h
	util.c
	util.h
	dmiopt.h
	dmiopt.c
	dmioem.c
	dmioem.h
	dmidecode.c
	dmidecode.h
	dmioutput.c
	dmioutput.h
)

target_link_libraries(dmidecode)
set(DMIDECODE_VERSION ${PROJECT_VERSION} PARENT_SCOPE)

=== debian/changelog ===
cpu-x (5.2.0-0.4) unstable; urgency=medium

  * NMU
  * Trigger build on x32 by bumping libcpuid-dev build dependency to 0.7.1

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 25 Mar 2025 10:19:09 +0000

cpu-x (5.2.0-0.3) unstable; urgency=medium

  * NMU
  * Build depend on libcpuid on x32

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 23 Mar 2025 16:46:17 +0000

cpu-x (5.2.0-0.2) unstable; urgency=medium

  * NMU
  * Patch to allow arch i686 instead of just X86
  * Add arm and x32 architectures to debian/control file

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 23 Mar 2025 14:39:38 +0000

cpu-x (5.2.0-0.1) unstable; urgency=medium

  * NMU
  * New upstream release
  * Update build dependencies:
    - tighten cmake version requirement
    - need libegl-dev instead of libglfw3-dev
    - need opencl-headers; opencl now on by default
  * Forward port quilt patches

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 22 Mar 2025 15:17:24 +0000

=== debian/control ===
Source: cpu-x
Section: x11
Priority: optional
Maintainer: Martin Wimpress <code@wimpress.io>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.12),
               gawk,
               gettext,
               libcpuid-dev (>= 0.7.1) [amd64 i386 x32],
               libgtkmm-3.0-dev (>= 3.12),
               libcurl4-gnutls-dev,
               libegl-dev (>= 1.5),
               libjson-c-dev,
               libncurses-dev,
               libpci-dev (>= 3.13),
               libproc2-dev,
               libstatgrab-dev,
               libvulkan-dev,
               opencl-headers,
               nasm,
               pkgconf,
               procps,
Standards-Version: 4.7.2
Homepage: https://github.com/X0rg/CPU-X
Vcs-Git: https://salsa.debian.org/debian/cpu-x.git
Vcs-Browser: https://salsa.debian.org/debian/cpu-x
Rules-Requires-Root: no

Package: cpu-x
Architecture: amd64 i386 arm64 armel armhf x32
Depends: ${shlibs:Depends},
         ${misc:Depends},
         procps,
Description: Tool that gathers information on CPU, motherboard and more
 CPU-X is similar to CPU-Z (for MS Windows). It can be used in graphical
 mode by using GTK or in text-based mode by using NCurses. A dump mode is
 present from the command line.

## cpu-x 5.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,16 +4,31 @@
 	cmake_policy(SET CMP0177 NEW)
 endif()
 project(cpu-x
-	VERSION "5.2.0"
+	VERSION "5.3.1"
 	LANGUAGES C CXX
 )
 
+# Check for x86 CPU
+if(CMAKE_SYSTEM_PROCESSOR MATCHES "^i.86$|(x86)|(X86)|(amd64)|(AMD64)")
+	set(CPU_ISA_X86 TRUE)
+else()
+	set(CPU_ISA_X86 FALSE)
+endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^i.86$|(x86)|(X86)|(amd64)|(AMD64)")
+
+# Check for ARM CPU
+if(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64")
+	set(CPU_ISA_ARM TRUE)
+else()
+	set(CPU_ISA_ARM FALSE)
+endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64")
+
+# Check if platform is supported
 if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD")
 	message(WARNING "'${CMAKE_SYSTEM_NAME}' system is not officially supported by CPU-X, some features will not be available.")
 endif(NOT CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD")
-if(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)|^armv.*|aarch64")
-	message(FATAL_ERROR "'${CMAKE_SYSTEM_PROCESSOR}' processor is not supported by CPU-X.")
-endif(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)|^armv.*|aarch64")
+if(NOT CPU_ISA_X86 AND NOT CPU_ISA_ARM)
+	message(WARNING "'${CMAKE_SYSTEM_PROCESSOR}' processor is not officially supported by CPU-X, some features will not be available.")
+endif(NOT CPU_ISA_X86 AND NOT CPU_ISA_ARM)
 
 
 ### DEFAULT CONFIG
@@ -71,11 +86,11 @@
 option(WITH_LIBPROCPS     "Use Libprocps library"                                             ON)
 option(WITH_LIBSTATGRAB   "Use Libstatgrab library"                                           ON)
 option(WITH_DMIDECODE     "Built-in Dmidecode"                                                ON)
-if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
+if(CPU_ISA_X86)
 	option(WITH_BANDWIDTH "Built-in Bandwidth"                                                ON) # Bandwidth is only supported on x86 CPUs (requires cache size)
 else()
 	set(WITH_BANDWIDTH OFF)
-endif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
+endif(CPU_ISA_X86)
 option(FORCE_LIBSTATGRAB  "Force use of Libstatgrab instead of Libprocps (GNU/Linux system)"  OFF)
 option(APPIMAGE           "Enable workarounds for AppImage"                                   OFF)
 option(FLATPAK            "Enable workarounds for Flatpak"                                    OFF)
@@ -100,26 +115,49 @@
 set(BoldWhite   "${Esc}[1;37m")
 
 
+### FUNCTIONS
+
+# Credits to jtanx: https://gist.github.com/jtanx/96ded5e050d5ee5b19804195ee5cf5f9
+# Function: pad_string(output str padchar length)
+# Add padding to a string
+# @output:  variable name for output string
+# @str:     input string
+# @padchar: character used for padding
+# @length:  padding length
+function(pad_string output str padchar length)
+	string(LENGTH "${str}" _strlen)
+	math(EXPR _strlen "${length} - ${_strlen}")
+	if(_strlen GREATER 0)
+		if(${CMAKE_VERSION} VERSION_LESS "3.14")
+			unset(_pad)
+			foreach(_i RANGE 1 ${_strlen}) # inclusive
+				string(APPEND _pad ${padchar})
+			endforeach()
+		else()
+			string(REPEAT ${padchar} ${_strlen} _pad)
+		endif()
+		string(APPEND str ${_pad})
+	endif()
+	set(${output} "${str}" PARENT_SCOPE)
+endfunction()
+
+
 ### MACROS
 
-# Macro: print_config(libname foundstate withstate)
+# Macro: print_config(libname libver withstate)
 # Print the state of CPU-X features: in bold green if enabled, else bold red.
 # @libname:    library name (e.g. GTK)
 # @libver:     library version (e.g. XXXXX_VERSION)
-# @foundstate: the result of pkg_check_modules(...) (e.g. XXXXX_FOUND)
 # @withstate:  the CMake option which allows to disable this feature (e.g. WITH_XXXXX)
-macro(print_config libname libver foundstate withstate)
-	if(${foundstate} AND ${withstate})
-		message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldGreen}enabled${ColourReset}")
+macro(print_config libname libver withstate)
+	pad_string(lib_string ${libname} " " 15)
+	if(${withstate})
+		message("${BoldCyan}**   ${lib_string}${ColourReset}\tsupport is ${BoldGreen}enabled${ColourReset} (version is ${libver})")
 		add_definitions(-DHAS_${libname}=1 -D${libname}_VERSION="${libver}")
-	else(${foundstate} AND ${withstate})
-		if(NOT ${withstate})
-			message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset} (explicitly disabled)")
-		elseif(NOT ${foundstate})
-			message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset} (not found by pkg-config)")
-		endif()
+	else(${withstate})
+		message("${BoldCyan}**   ${lib_string}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset}")
 		add_definitions(-DHAS_${libname}=0 -D${libname}_VERSION=NULL)
-	endif(${foundstate} AND ${withstate})
+	endif(${withstate})
 endmacro(print_config)
 
 
@@ -147,15 +185,16 @@
 find_package(Backtrace REQUIRED)
 find_package(Filesystem REQUIRED)
 if(WITH_GETTEXT)
-	find_package(Gettext)
+	find_package(Gettext REQUIRED)
 	if(${CMAKE_VERSION} VERSION_GREATER "3.1")
-		find_package(Intl)
+		find_package(Intl REQUIRED)
 	endif(${CMAKE_VERSION} VERSION_GREATER "3.1")
 endif(WITH_GETTEXT)
-include(CheckSymbolExists)
-include(CheckStructHasMember)
-include(CheckCSourceCompiles)
-include(CheckIncludeFile)
+#include(CheckSymbolExists)
+#include(CheckStructHasMember)
+#include(CheckCSourceCompiles)
+#include(CheckIncludeFile)
+include(CheckLanguage)
 add_subdirectory(data)
 add_subdirectory(po)
 add_subdirectory(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -11,30 +11,25 @@
 
 # GTK3+
 if(WITH_GTK)
-	set(MINIMUM_GTK_VERSION 3.12.0)
-	pkg_check_modules(GTK3 gtkmm-3.0>=${MINIMUM_GTK_VERSION})
+	pkg_check_modules(GTK3 REQUIRED gtkmm-3.0>=3.12.0)
 	if(GTK3_FOUND)
 		include_directories(${GTK3_INCLUDE_DIRS})
 		link_directories(${GTK3_LIBRARY_DIRS})
 		add_definitions(${GTK3_CFLAGS_OTHER})
-	else(GTK3_FOUND)
-		message("${BoldYellow}GTK3+ GUI will not be build:${ColourReset} ${Yellow}GTK ${MINIMUM_GTK_VERSION} or higher is needed.${ColourReset}")
-		message("${Yellow}Set ${BoldYellow}PKG_CONFIG_PATH${ColourReset}${Yellow} environment variable if development files are installed.${ColourReset}")
 	endif(GTK3_FOUND)
 endif(WITH_GTK)
 
 # NCurses
 if(WITH_NCURSES)
-	pkg_check_modules(NCURSES ncursesw)
-	# Assume ncurses from the base on FreeBSD
-	if(NOT NCURSES_FOUND AND CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
-		set(NCURSES_FOUND 1)
-		set(NCURSES_LIBRARIES "-l:libncursesw.so")
-	endif()
-	if(NCURSES_FOUND)
-		include_directories(${NCURSES_INCLUDE_DIRS})
-		link_directories(${NCURSES_LIBRARY_DIRS})
-	endif(NCURSES_FOUND)
+	set(CURSES_NEED_NCURSES TRUE)
+	set(CURSES_NEED_WIDE TRUE)
+	if(NOT CURSES_FOUND AND CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
+		set(CURSES_INCLUDE_PATH "/usr/local/include")
+	endif(NOT CURSES_FOUND AND CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
+	find_package(Curses REQUIRED)
+	if(CURSES_FOUND)
+		include_directories(${CURSES_INCLUDE_DIRS})
+	endif(CURSES_FOUND)
 endif(WITH_NCURSES)
 
 # Gettext
@@ -44,7 +39,7 @@
 
 # Libcpuid
 if(WITH_LIBCPUID)
-	pkg_check_modules(LIBCPUID libcpuid>=0.7.0)
+	pkg_check_modules(LIBCPUID REQUIRED libcpuid>=0.8.0)
 	if(LIBCPUID_FOUND)
 		include_directories(${LIBCPUID_INCLUDE_DIRS})
 		link_directories(${LIBCPUID_LIBRARY_DIRS})
@@ -55,7 +50,7 @@
 
 # Libpci
 if(WITH_LIBPCI)
-	pkg_check_modules(LIBPCI libpci)
+	pkg_check_modules(LIBPCI REQUIRED libpci)
 	if(LIBPCI_FOUND)
 		include_directories(${LIBPCI_INCLUDE_DIRS})
 		link_directories(${LIBPCI_LIBRARY_DIRS})
@@ -65,34 +60,30 @@
 
 # Libegl
 if(WITH_LIBEGL)
-	pkg_check_modules(LIBGL gl)
-	pkg_check_modules(LIBEGL egl>1.4)
-	if(LIBGL_FOUND AND LIBEGL_FOUND)
-		include_directories(${LIBGL_INCLUDE_DIRS} ${LIBEGL_INCLUDE_DIRS})
-		link_directories(${LIBGL_LIBRARY_DIRS} ${LIBEGL_LIBRARY_DIRS})
-		add_definitions(${LIBGL_CFLAGS_OTHER} ${LIBEGL_CFLAGS_OTHER})
-		set(LIBOPENGL_LIBRARIES ${LIBGL_LIBRARIES} ${LIBEGL_LIBRARIES})
-	endif(LIBGL_FOUND AND LIBEGL_FOUND)
+	pkg_check_modules(LIBEGL REQUIRED egl>1.4)
+	find_package(OpenGL REQUIRED COMPONENTS OpenGL EGL)
+	if(LIBEGL_FOUND AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
+		include_directories(${OPENGL_INCLUDE_DIRS} ${OPENGL_EGL_INCLUDE_DIRS})
+		set(LIBOPENGL_LIBRARIES OpenGL::OpenGL OpenGL::EGL)
+	endif(LIBEGL_FOUND AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
 endif(WITH_LIBEGL)
 
 # Vulkan
 if(WITH_VULKAN)
-	pkg_check_modules(VULKAN vulkan)
-	if(VULKAN_FOUND)
-		include_directories(${VULKAN_INCLUDE_DIRS})
-		link_directories(${VULKAN_LIBRARY_DIRS})
-		add_definitions(${VULKAN_CFLAGS_OTHER})
-	endif(VULKAN_FOUND)
+	find_package(Vulkan REQUIRED)
+	if(Vulkan_FOUND)
+		include_directories(${Vulkan_INCLUDE_DIRS})
+		set(LIBVUKLAN_LIBRARIES ${Vulkan_LIBRARIES})
+	endif(Vulkan_FOUND)
 endif(WITH_VULKAN)
 
 # OpenCL
 if(WITH_OPENCL)
-	pkg_check_modules(OPENCL OpenCL)
-	if(OPENCL_FOUND)
-		include_directories(${LIBOPENCL_INCLUDE_DIRS} ${OpenCL_INCLUDE_DIRS})
-		link_directories(${LIBOPENCL_LIBRARY_DIRS} ${OpenCL_LIBRARY_DIRS})
-		add_definitions(${LIBOPENCL_CFLAGS_OTHER} ${OpenCL_CFLAGS_OTHER})
-	endif(OPENCL_FOUND)
+	find_package(OpenCL REQUIRED)
+	if(OpenCL_FOUND)
+		include_directories(${OpenCL_INCLUDE_DIRS})
+		set(LIBOPENCL_LIBRARIES ${OpenCL_LIBRARIES})
+	endif(OpenCL_FOUND)
 endif(WITH_OPENCL)
 
 # Libprocps
@@ -100,7 +91,7 @@
 set(LIBSYSTEM 0)
 set(LIBPROC2 -1)
 if(WITH_LIBPROCPS AND CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
-	pkg_check_modules(LIBPROC2 libproc2)
+	pkg_check_modules(LIBPROC2 libproc2) # REQUIRED not present here to allow to fallback to libprocps
 	if(LIBPROC2_FOUND)
 		include_directories(${LIBPROC2_INCLUDE_DIRS})
 		link_directories(${LIBPROC2_LIBRARY_DIRS})
@@ -109,7 +100,7 @@
 		set(LIBSYSTEM 1)
 		set(LIBPROC2 1)
 	else()
-		pkg_check_modules(LIBPROCPS libprocps)
+		pkg_check_modules(LIBPROCPS REQUIRED libprocps)
 		set(LIBPROC2 0)
 	endif()
 	if(LIBPROCPS_FOUND)
@@ -123,7 +114,7 @@
 
 # Libstatgrab
 if(WITH_LIBSTATGRAB AND (NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR FORCE_LIBSTATGRAB))
-	pkg_check_modules(LIBSTATGRAB libstatgrab)
+	pkg_check_modules(LIBSTATGRAB REQUIRED libstatgrab)
 	if(LIBSTATGRAB_FOUND)
 		include_directories(${LIBSTATGRAB_INCLUDE_DIRS})
 		link_directories(${LIBSTATGRAB_LIBRARY_DIRS})
@@ -141,13 +132,13 @@
 endif(WITH_DMIDECODE)
 
 # Bandwidth
-if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" AND WITH_BANDWIDTH)
+if(CPU_ISA_X86 AND WITH_BANDWIDTH)
 	add_subdirectory(core/bandwidth)
 	if(BANDWIDTH_FOUND)
 		include_directories(core/bandwidth)
 		set(BANDWIDTH_LIBRARIES "bandwidth")
 	endif(BANDWIDTH_FOUND)
-endif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" AND WITH_BANDWIDTH)
+endif(CPU_ISA_X86 AND WITH_BANDWIDTH)
 
 
 ### FINAL CONFIG
@@ -155,29 +146,29 @@
 message("${BoldCyan}** ${CMAKE_PROJECT_NAME} ${PROJECT_VERSION} configuration (${CMAKE_SYSTEM_PROCESSOR}) **${ColourReset}")
 
 # UI libraries
-print_config("GTK"                 "${GTK3_VERSION}"        GTK3_FOUND        WITH_GTK)
-print_config("NCURSES"             "${NCURSES_VERSION}"     NCURSES_FOUND     WITH_NCURSES)
+print_config("GTK"                 "${GTK3_VERSION}"            WITH_GTK)
+print_config("NCURSES"             "${NCURSES_VERSION}"         WITH_NCURSES)
 
 # Other libraries
-print_config("GETTEXT"             0                        GETTEXT_FOUND     WITH_GETTEXT)
-print_config("LIBCPUID"            "${LIBCPUID_VERSION}"    LIBCPUID_FOUND    WITH_LIBCPUID)
-print_config("LIBPCI"              "${LIBPCI_VERSION}"      LIBPCI_FOUND      WITH_LIBPCI)
-print_config("LIBEGL"              "${LIBEGL_VERSION}"      LIBEGL_FOUND      WITH_LIBEGL)
-print_config("VULKAN"              "${VULKAN_VERSION}"      VULKAN_FOUND      WITH_VULKAN)
-print_config("OPENCL"              "${OPENCL_VERSION}"      OPENCL_FOUND      WITH_OPENCL)
+print_config("GETTEXT"             "${GETTEXT_VERSION_STRING}"  WITH_GETTEXT)
+print_config("LIBCPUID"            "${LIBCPUID_VERSION}"        WITH_LIBCPUID)
+print_config("LIBPCI"              "${LIBPCI_VERSION}"          WITH_LIBPCI)
+print_config("LIBEGL"              "${LIBEGL_VERSION}"          WITH_LIBEGL)
+print_config("VULKAN"              "${Vulkan_VERSION}"          WITH_VULKAN)
+print_config("OPENCL"              "${OpenCL_VERSION_STRING}"   WITH_OPENCL)
 if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
 	if(${LIBPROC2} EQUAL 1)
-		print_config("LIBPROC2"    "${LIBPROC2_VERSION}"    LIBPROC2_FOUND    WITH_LIBPROCPS)
+		print_config("LIBPROC2"    "${LIBPROC2_VERSION}"        WITH_LIBPROCPS)
 	else()
-		print_config("LIBPROCPS"   "${LIBPROCPS_VERSION}"   LIBPROCPS_FOUND   WITH_LIBPROCPS)
+		print_config("LIBPROCPS"   "${LIBPROCPS_VERSION}"       WITH_LIBPROCPS)
 	endif()
 else()
-	print_config("LIBSTATGRAB" "${LIBSTATGRAB_VERSION}" LIBSTATGRAB_FOUND WITH_LIBSTATGRAB)
+	print_config("LIBSTATGRAB"     "${LIBSTATGRAB_VERSION}"     WITH_LIBSTATGRAB)
 endif()
 
 # Subprojects
-print_config("DMIDECODE"           "${DMIDECODE_VERSION}"   1                 WITH_DMIDECODE)
-print_config("BANDWIDTH"           "${BANDWIDTH_VERSION}"   BANDWIDTH_FOUND   WITH_BANDWIDTH)
+print_config("DMIDECODE"           "${DMIDECODE_VERSION}"       WITH_DMIDECODE)
+print_config("BANDWIDTH"           "${BANDWIDTH_VERSION}"       WITH_BANDWIDTH)
 
 
 ### BINARIES
@@ -259,29 +250,29 @@
 endif(WITH_LIBPCI AND LIBPCI_FOUND)
 
 # Libegl
-if(WITH_LIBEGL AND LIBGL_FOUND AND LIBEGL_FOUND)
+if(WITH_LIBEGL AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
 	target_sources(${APP_EXEC}
 		PRIVATE
 		core/libopengl.cpp
 	)
-endif(WITH_LIBEGL AND LIBGL_FOUND AND LIBEGL_FOUND)
+endif(WITH_LIBEGL AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
 
 # Vulkan
-if(WITH_VULKAN AND VULKAN_FOUND)
+if(WITH_VULKAN AND Vulkan_FOUND)
 	target_sources(${APP_EXEC}
 		PRIVATE
 		core/libvulkan.cpp
 	)
-endif(WITH_VULKAN AND VULKAN_FOUND)
+endif(WITH_VULKAN AND Vulkan_FOUND)
 
 # OpenCL
-if(WITH_OPENCL AND OPENCL_FOUND)
+if(WITH_OPENCL AND OpenCL_FOUND)
 	target_sources(${APP_EXEC}
 		PRIVATE
 		core/libopencl.cpp
 		core/opencl_ext.h
 	)
-endif(WITH_OPENCL AND OPENCL_FOUND)
+endif(WITH_OPENCL AND OpenCL_FOUND)
 
 # Libsystem (libproc2/libprocps/libstatgrab)
 if(${LIBSYSTEM} GREATER 0)
@@ -332,9 +323,9 @@
 endif()
 
 # ARM CPUs workarounds
-if(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64" AND CMAKE_SYSTEM_NAME MATCHES "Linux")
+if(CPU_ISA_ARM AND CMAKE_SYSTEM_NAME MATCHES "Linux")
 	set(OTHER_LIBRARIES "-latomic")
-endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64" AND CMAKE_SYSTEM_NAME MATCHES "Linux")
+endif(CPU_ISA_ARM AND CMAKE_SYSTEM_NAME MATCHES "Linux")
 
 # AppImage workarounds
 if(APPIMAGE)
@@ -377,12 +368,12 @@
 	std::filesystem
 
 	${GTK3_LIBRARIES}
-	${NCURSES_LIBRARIES}
+	${CURSES_LIBRARIES}
 	${LIBCPUID_LIBRARIES}
 	${LIBPCI_LIBRARIES}
 	${LIBOPENGL_LIBRARIES}
-	${VULKAN_LIBRARIES}
-	${OPENCL_LIBRARIES}
+	${LIBVUKLAN_LIBRARIES}
+	${LIBOPENCL_LIBRARIES}
 	${LIBSYSTEM_LIBRARIES}
 	${DMIDECODE_LIBRARIES}
 	${BANDWIDTH_LIBRARIES}

=== src/core/bandwidth/CMakeLists.txt ===
project(bandwidth
	VERSION "1.5.1"
	LANGUAGES C
)

# Config (bandwidth)
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wno-strict-prototypes -Wno-sign-compare")

if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
	set(NASM_FLAGS_DEBUG "-gdwarf")
endif(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")

# Build (bandwidth)
check_language(ASM_NASM)
if(CMAKE_ASM_NASM_COMPILER)
	enable_language(ASM_NASM)
	set(BANDWIDTH_FOUND ON PARENT_SCOPE)
	message(STATUS "Using built-in ${PROJECT_NAME}, version ${PROJECT_VERSION}")

	if(BITNESS EQUAL 32)
		set(ROUTINES "routines-x86-32bit")
		add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			COMMAND ${CMAKE_ASM_NASM_COMPILER} ${NASM_FLAGS_DEBUG} -f elf ${ROUTINES}.asm -o ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		)
	elseif(BITNESS EQUAL 64)
		set(ROUTINES "routines-x86-64bit")
		add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			COMMAND ${CMAKE_ASM_NASM_COMPILER} ${NASM_FLAGS_DEBUG} -f elf64 ${ROUTINES}.asm -o ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		)
	endif()

	if(LIBCPUID_FOUND AND WITH_LIBCPUID)
		add_definitions(-DHAS_LIBCPUID=1)
	else(LIBCPUID_FOUND AND WITH_LIBCPUID)
		add_definitions(-DHAS_LIBCPUID=0)
	endif(LIBCPUID_FOUND AND WITH_LIBCPUID)

	add_library(bandwidth
		STATIC
		BMP.c
		BMPGraphing.c
		font.c
		main.c
		minifont.c
		libbandwidth.h
		${ROUTINES}.o
	)

	target_link_libraries(bandwidth)
	set(BANDWIDTH_VERSION ${PROJECT_VERSION} PARENT_SCOPE)

else(CMAKE_ASM_NASM_COMPILER)
	set(BANDWIDTH_FOUND OFF PARENT_SCOPE)
endif(CMAKE_ASM_NASM_COMPILER)

=== debian/changelog ===
cpu-x (5.3.1-0.3) unstable; urgency=medium

  * NMU
  * disable BANDWIDTH option on x32, since it uses assembly code

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 14 May 2025 13:06:36 +0100

cpu-x (5.3.1-0.2) unstable; urgency=medium

  * NMU
  * Target unstable with ARM support

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 12 May 2025 21:39:05 +0100

cpu-x (5.3.1-0.1) experimental; urgency=medium

  * NMU
  * bump libcpuid-dev build dependency to 0.8.0 per upstream
  * forward port patches, the i686 check one is obsolete
  * Use libcpuid (>= 0.8.0-0.2) which supports ARM
  * Newly-Required build dependencies on Vulkan and OpenCL ICD loader

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 12 May 2025 18:06:36 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                cmake (>= 3.12),
                gawk,
                gettext,
-               libcpuid-dev (>= 0.7.1) [amd64 i386 x32],
+               libcpuid-dev (>= 0.8.0+repack1-0.3),
                libgtkmm-3.0-dev (>= 3.12),
                libcurl4-gnutls-dev,
                libegl-dev (>= 1.5),
@@ -18,7 +18,11 @@
                libproc2-dev,
                libstatgrab-dev,
                libvulkan-dev,
+	       vulkan-validationlayers,
+	       glslang-tools,
+	       glslc,
                opencl-headers,
+	       ocl-icd-opencl-dev,
                nasm,
                pkgconf,
                procps,
@@ -29,7 +33,7 @@
 Rules-Requires-Root: no
 
 Package: cpu-x
-Architecture: amd64 i386 arm64 armel armhf x32
+Architecture: any-linux-amd64 any-linux-i386 any-linux-arm any-linux-armeb any-linux-arm64
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          procps,
